#include "stdafx.h"


///////////////////////////////////////////
//this function returns the evaluation.
///////////////////////////////////////////
int Evaluate(int W, int B)
{
	//some statistics
	PositionCounter = PositionCounter + 1;

	return W-B;
}


///////////////////////////////////////////
//this function calculates white's score
//it uses Chromosome' values
///////////////////////////////////////////
int EvaluateWhite()
{	
		//score
	int White=0,

		//some flags
		BishopPairStatus=0,
		RookConnectionStatus=0,
		CastlingCheckedStatus=0,

		i=0;

	//to make a little speed up
	__int64 KnightMoves=0;


	//the evaluation procedure processes the board square by square
	for(i=0;i<64;i++)
	{
		//castling
		if (CastlingCheckedStatus == 0)	
		{
			if(WhiteCastlingDone == true)
				White += Chromosome[CASTLING_DONE];
			else
			{
				if ((WhiteShortCastling == false) && (WhiteLongCastling == false))
					White -= Chromosome[CASTLING_MISSED];
			}

			//infrom the program that castling options have been considered
			CastlingCheckedStatus++;
			
		}
		
		//queen
		if((Squares[i] & BitBoards[2]) != 0)
		{
			White+=Chromosome[QUEEN];

			//every attack on the corresponding square reduces the score by x/10 value
			if ((IsAttacked(i,0)-IsAttacked(i,7)) < 0)
				White -= (Chromosome[QUEEN]/10);
		}
		
		//rook
		else 
		if((Squares[i] & BitBoards[3]) != 0)
		{
			White+=Chromosome[ROOK];

			//every attack on the corresponding square reduces the score by x/10 value
			if ((IsAttacked(i,0)-IsAttacked(i,7)) < 0)
				White -= (Chromosome[ROOK]/10);
			
		/********* "rook on an open file" &      
				   "rook on a semi-open file" bonuses are given here *******/
			int tmp=i-8;
			int flag=0;
			//0 - open
			//1 - semi-open
			//2 - closed

			//below the rook
			while ((tmp>7) && (flag != 2))
			{
				//neither open nor semi-open, in fact,
				//and no reason to consider further
				if (WhichPiece(tmp) == 6)
				{
					flag=2;
					break;
				}
				else 
					if(WhichPiece(tmp) == 13)
						flag = 1;
				
				tmp -= 8;
			}

			//above the rook
			if(flag != 2)
			{
				tmp=i+8;
				while ((tmp<63) && (flag != 2))
				{
					if (WhichPiece(tmp) == 6)
					{
						flag=2;
						break;
					}
					else 
						if(WhichPiece(tmp) == 13)
							flag = 1;

					tmp += 8;
				}
			}

			if (flag == 0)
				White+=Chromosome[ROOK_OPEN_FILE];
			else
				if (flag == 1)
					White+=Chromosome[ROOK_SOPEN_FILE];

			/********* "rook on the 7th line" bonus is given here *******/
			if ((i>47) && (i<56))
				White+=Chromosome[LINE7_ROOK];
	
			/********* "connected rooks" bonus is given here *******/
			if (RookConnectionStatus == 0)
			{
	
				for (int direction = 0; direction < 4; direction++)
				{
					int j=0;
					while((RookMoves[i][direction][j] != -1) && j<7 )
					{
						//if the square is empty,
						//then continue 
						if (WhichPiece(RookMoves[i][direction][j]) == -1)
						{
							j++;
							continue;
						}
						//if the square is NOT empty
						else
						{
							//the square is occupied by a friendly rook
							if (WhichPiece(RookMoves[i][direction][j]) == 3) 
								White += Chromosome[CONNECTED_ROOKS];
							
							break;
						}
					}// end of while
				}// end of for
	
				//inform the machine not to consider rooks' connection twice
				RookConnectionStatus++;
			}			
		}
		
		//bishop
		else 
		if((Squares[i] & BitBoards[4]) != 0)
		{
			White+=Chromosome[BISHOP];
			
			if ((IsAttacked(i,0)-IsAttacked(i,7)) < 0)
				White -= (Chromosome[BISHOP]/10);

			//"bishop on the first line" is considered here
			if (i<8)
				White -= Chromosome[LINE1_BISHOP];
			
			//"bishop pair" is considered here
			if(BishopPairStatus == 0)
				BishopPairStatus++;
			else
				White+=Chromosome[BISHOP_PAIR];

		/********* "bishop's outpost" bonus is given here *******/
			/*fields within the area c5-f6*/
			if( ((i>33) && (i<38)) || ((i>41) && (i<46))  )
			{
				if ( (WhichPiece(i-9) == 6) || (WhichPiece(i-7) == 6) )
					White += Chromosome[BISHOP_OUTPOST];

			}

		}	

		//knight
		else 
		if((Squares[i] & BitBoards[5]) != 0)
		{
			White+=Chromosome[KNIGHT];

			if ((IsAttacked(i,0)-IsAttacked(i,7)) < 0)
				White -= (Chromosome[KNIGHT]/10);

		/********* "knight's mobility" bonus is given here *******/
			//and "knight on the first line" is considered here
			if (i<8)
				White -= Chromosome[LINE1_KNIGHT];
			else
			{			
				KnightMoves = ComputeMoves(5,i);

				int j=0,
					Moves=0;

				if((i+6)<64)
				{
					if ((KnightMoves & Squares[i+6]) != 0)
						Moves++;
				
					if((i+10)<64)
					{
						if ((KnightMoves & Squares[i+10]) != 0)
							Moves++;
						
						if((i+15)<64)
						{
							if ((KnightMoves & Squares[i+15]) != 0)
								Moves++;
						
							if((i+17)<64)
								if ((KnightMoves & Squares[i+17]) != 0)
									Moves++;
						}
					}
				}

				if((i-6) > -1)
				{
					if ((KnightMoves & Squares[i-6]) != 0)
						Moves++;
				
					if((i-10) > -1)
					{
						if ((KnightMoves & Squares[i-10]) != 0)
							Moves++;
					
						if((i-15) > -1)
						{
							if ((KnightMoves & Squares[i-15]) != 0)
								Moves++;
						
							if((i-17) > -1)
								if ((KnightMoves & Squares[i-17]) != 0)
									Moves++;
						}
					}
				}
			
				if(Moves > 5)
					White+=Chromosome[KNIGHT_MOBILITY];
			}
		
			/********* "knight's outpost" bonus is given here *******/
			/*fields within the area b5-g7, but without b7 and g7*/
			if( ((i>32) && (i<39)) || ((i>40) && (i<47)) || ((i>49) && (i<54)) )
			{
				if ( (WhichPiece(i-9) == 6) || (WhichPiece(i-7) == 6) )
					White += Chromosome[KNIGHT_OUTPOST];
			}
		}

		//pawn		
		else 
		if((Squares[i] & BitBoards[6]) != 0)
		{
			White+=Chromosome[PAWN];

			if ((IsAttacked(i,0)-IsAttacked(i,7)) < 0)
				White -= (Chromosome[PAWN]/10);
			else
				if(i>39)
					White += Chromosome[FAR_PAWN];

			bool isolated = false;
			int adjacent = 0;

			/*********"centre pawn" is considered here*******/
			if((i==27) || (i==28) || (i==35) || (i==36))
				White+=Chromosome[CENTRE_PAWN];
					
			/*********"blocked pawn" is considered here*******/
			if((i==11) || (i==12) || (i==19) || (i==20))
			{
				int tmp=WhichPiece(i+8);

				if((tmp > 8) && (tmp < 14))
					White -= Chromosome[BLOCKED_PAWN];
			}

			/*********"doubled pawn" is considered here*******/
			if( (i<48))
			{
				if (WhichPiece(i+8) == 6)
					White -= Chromosome[DOUBLED_PAWNS];
				else
					if( (i<40))
					{
						if (WhichPiece(i+16) == 6)
							White -= Chromosome[DOUBLED_PAWNS];
						else
							if((i<32))
							{
								if(WhichPiece(i+24) == 6)
									White -= Chromosome[DOUBLED_PAWNS];
								else
									if((i<24))
									{
										if(WhichPiece(i+32) == 6)
											White -= Chromosome[DOUBLED_PAWNS];
										else
											if((i<16))
											{
												if (WhichPiece(i+40) == 6)
													White -= Chromosome[DOUBLED_PAWNS];
											}
									}
							}
					}
			}
		
			/*********"passed pawn" is considered here*******/
			int flag=0;

			if((i==8) || (i==16) || (i==24) || (i==32) || (i==40) )
			{
				for(int k=49;k>(i+1);k=k-8)
					if((WhichPiece(k) == 13) || (WhichPiece(k-1) == 13))
					{
						flag=1;
						break;
					}
			}
			else
				if((i==15) || (i==23) || (i==31) || (i==39) || (i==47) )
				{
					for(int k=54;k>(i-1);k=k-8)
						if((WhichPiece(k) == 13) || (WhichPiece(k-1) == 13))
						{
							flag=1;
							break;
						}
				}
				else
					if ((i>8) && (i<47))
					{
						for(int k=i+7;k<54;k=k+8)
							if((WhichPiece(k) == 13) || (WhichPiece(k+1) == 13) || (WhichPiece(k+2) == 13))
							{
								flag=1;
								break;
							}
					}

			if (flag == 0)
			{
				White += Chromosome[PASSED_PAWN];
			
				/*********"rook-supported passed pawn" bonus is given here*******/
				int k=i;
				while (k>7)
				{
					k -= 8;
					if (WhichPiece(k) != -1)
						if (WhichPiece(k) == 3)
							White += Chromosome[ROOK_SUPP_PASSED_PAWN];
						else 
							break;
				}
			}

			/*********"isolated pawn" is considered here*******/
			flag=0;
			if((i==8) || (i==16) || (i==24) || (i==32) || (i==40) || (i==48))
			{
				for(int k=49;k>1;k=k-8)
					if(WhichPiece(k) == 6)
					{
						flag=1;
						break;
					}
			}
			else
				if((i==15) || (i==23) || (i==31) || (i==39) || (i==47) || (i==55))
				{
					for(int k=54;k>6;k=k-8)
						if(WhichPiece(k) == 6)
						{
							flag=1;
							break;
						}
				}
				else
					if ((i>8) && (i<54))
					{
						int tmp=i;
						while (tmp>15)
							tmp-=8;
						
						for(int k=(tmp-1);k<=(tmp+40);k=k+8)
							if((WhichPiece(k) == 6) || (WhichPiece(k+2) == 6))
							{
								flag=1;
								break;
							}
					}

			if (flag == 0)
			{
				isolated = true;
				White -= Chromosome[ISOLATED_PAWN];
			}
	
			/*********"backward pawn" and "adjacent pawn" are considered here*******/
			flag = 1;
			if(isolated == true)
			{
				flag=0;
				adjacent = 0;
			}
			else
				if (i>7)
				{
					if((i==8) || (i==16) || (i==24) || (i==32) || (i==40) || (i==48))
					{
						for(int k=i-7;k>1;k=k-8)
							if(WhichPiece(k) == 6)
							{
								if (k == i-7)
									adjacent++;

								flag=0;
								break;
							}
					}
					else
						if((i==15) || (i==23) || (i==31) || (i==39) || (i==47) || (i==55))
						{
							for(int k=i-9;k>6;k=k-8)
								if(WhichPiece(k) == 6)
								{
									if (k == i-9)
										adjacent++;

									flag=0;
									break;
								}
						}
						else
							if (i<55)
							{
								for(int k=i-9;k>7;k=k-8)
								{
									if(WhichPiece(k) == 6)
									{
										if (k == i-9)
											adjacent++;
										
										flag=0;
									}

									if(WhichPiece(k+2) == 6)
									{
										if (k == i-9)
											adjacent++;
									
										flag=0;
									}

									if (flag == 0)
										break;
								}
							}
				}
			if (flag == 1)
				White -= Chromosome[BACKWARD_PAWN];
			
			while(adjacent>0)
			{
				White += Chromosome[ADJACENT_PAWN];
				adjacent--;
			}
		}//end of pawn if

	}//end of main loop

	return White;
}


///////////////////////////////////////////
//this function calculates black's score
//in exactly the same manner as it is for white
///////////////////////////////////////////
int EvaluateBlack()
{
	int Black=0,

		BishopPairStatus=0,
		RookConnectionStatus=0,
		CastlingCheckedStatus=0,

		i=0;

	__int64 KnightMoves=0;

	for(i=0;i<64;i++)
	{
		if (CastlingCheckedStatus == 0)	
		{
			if(BlackCastlingDone == true)
				Black += Chromosome[CASTLING_DONE];
			else
			{
				if ((BlackShortCastling == false) && (BlackLongCastling == false))
					Black -= Chromosome[CASTLING_MISSED];
			}

			CastlingCheckedStatus++;
		}

		//queen
		if((Squares[i] & BitBoards[9]) != 0)
		{
			Black+=Chromosome[QUEEN];
		
			if ((IsAttacked(i,7)-IsAttacked(i,0)) < 0)
				Black -= (Chromosome[QUEEN]/10);
		}
		else 
		
		//rook
		if((Squares[i] & BitBoards[10]) != 0)
		{
			Black+=Chromosome[ROOK];

			if ((IsAttacked(i,7)-IsAttacked(i,0)) < 0)
				Black -= (Chromosome[ROOK]/10);
					
		/********* "rook on an open file" &      
				   "rook on a semi-open file" bonuses are given here *******/
			int tmp=i-8;
			int flag=0;
			//0 - open
			//1 - semi-open
			//2 - closed

			//above the rook
			while ((tmp>7) && (flag != 2))
			{
				//neither open nor semi-open, in fact,
				//and no reason to consider further
				if (WhichPiece(tmp) == 6)
				{
					flag=2;
					break;
				}
				else 
					if(WhichPiece(tmp) == 13)
						flag = 1;
				
				tmp -= 8;
			}

			//below the rook
			if(flag != 2)
			{
				tmp=i+8;
				while ((tmp<63) && (flag != 2))
				{
					if (WhichPiece(tmp) == 6)
					{
						flag=2;
						break;
					}
					else 
						if(WhichPiece(tmp) == 13)
							flag = 1;

					tmp += 8;
				}
			}

			if (flag == 0)
				Black+=Chromosome[ROOK_OPEN_FILE];
			else
				if (flag == 1)
					Black+=Chromosome[ROOK_SOPEN_FILE];
		
		/********* "rook on the 7th line" bonus is given here *******/
			if ((i>7) && (i<16))
				Black+=Chromosome[LINE7_ROOK];
	
		/********* "connected rooks" bonus is given here *******/
			if (RookConnectionStatus == 0)
			{
	
				for (int direction = 0; direction < 4; direction++)
				{
					int j=0;
					while((RookMoves[i][direction][j] != -1) && j<7 )
					{
						//if the square is empty,
						//then continue 
						if (WhichPiece(RookMoves[i][direction][j]) == -1)
						{
							j++;
							continue;
						}
						//if the square is NOT empty
						else
						{
							//the square is occupied by a friendly rook
							if (WhichPiece(RookMoves[i][direction][j]) == 10) 
								Black += Chromosome[CONNECTED_ROOKS];
							
							break;
						}
					}// end of while
				}// end of for
	
				RookConnectionStatus++;
			}
		}
		else 
		
		//bishop
		if((Squares[i] & BitBoards[11]) != 0)
		{
			Black+=Chromosome[BISHOP];
			
			if ((IsAttacked(i,7)-IsAttacked(i,0)) < 0)
				Black -= (Chromosome[BISHOP]/10);

			//"bishop on the first line" is considered here
			if (i>55)
				Black -= Chromosome[LINE1_BISHOP];

			//"bishop pair" is considered here
			if(BishopPairStatus == 0)
				BishopPairStatus++;
			else
				Black+=Chromosome[BISHOP_PAIR];

		/********* "bishop's outpost" bonus is given here *******/
			/*fields within the area c3-f4*/
			if( ((i>17) && (i<22)) || ((i>25) && (i<30))  )
			{
				if ( (WhichPiece(i+9) == 13) || (WhichPiece(i+7) == 13) )
					Black += Chromosome[BISHOP_OUTPOST];

			}

		}	
		else 
		
		//knight
		if((Squares[i] & BitBoards[12]) != 0)
		{
			Black+=Chromosome[KNIGHT];

			if ((IsAttacked(i,7)-IsAttacked(i,0)) < 0)
				Black -= (Chromosome[KNIGHT]/10);

		/********* "knight's mobility" bonus is given here *******/
			//and "knight on the first line" is considered here
			if (i>55)
				Black -= Chromosome[LINE1_KNIGHT];
			else
			{
				KnightMoves = ComputeMoves(12,i);

				int j=0,
					Moves=0;

			
				if((i+6)<64)
				{
					if ((KnightMoves & Squares[i+6]) != 0)
						Moves++;
				
					if((i+10)<64)
					{
						if ((KnightMoves & Squares[i+10]) != 0)
							Moves++;
					
						if((i+15)<64)
						{
							if ((KnightMoves & Squares[i+15]) != 0)
								Moves++;
							
							if((i+17)<64)
								if ((KnightMoves & Squares[i+17]) != 0)
									Moves++;
						}
					}
				}

				if((i-6) > -1)
				{
					if ((KnightMoves & Squares[i-6]) != 0)
						Moves++;
				
					if((i-10) > -1)
					{
						if ((KnightMoves & Squares[i-10]) != 0)
							Moves++;
					
						if((i-15) > -1)
						{
							if ((KnightMoves & Squares[i-15]) != 0)
								Moves++;
						
							if((i-17) > -1)
								if ((KnightMoves & Squares[i-17]) != 0)
									Moves++;
						}
					}
				}
			
				if(Moves > 5)
					Black+=Chromosome[KNIGHT_MOBILITY];
			}
		
		/********* "knight's outpost" bonus is given here *******/
			/*fields within the area b2-g4, but without b2 and g2*/
			if( ((i>9) && (i<14)) || ((i>16) && (i<23)) || ((i>24) && (i<31)) )
			{
				if ( (WhichPiece(i+9) == 13) || (WhichPiece(i+7) == 13) )
					Black += Chromosome[KNIGHT_OUTPOST];

			}
		
		}
		
		
		else 
		
		//pawn
		if((Squares[i] & BitBoards[13]) != 0)
		{
			Black+=Chromosome[PAWN];

			if ((IsAttacked(i,7)-IsAttacked(i,0)) < 0)
				Black -= (Chromosome[PAWN]/10);
			else
				if(i<24)
					Black += Chromosome[FAR_PAWN];

			bool isolated = false;
			int adjacent = 0;

		/*********"centre pawn" is considered here*******/
			if((i==27) || (i==28) || (i==35) || (i==36))
				Black+=Chromosome[CENTRE_PAWN];
					
		/*********"blocked pawn" is considered here*******/
			if((i==43) || (i==44) || (i==51) || (i==52))
			{
				int tmp=WhichPiece(i-8);

				if((tmp > 1) && (tmp < 7))
					Black -= Chromosome[BLOCKED_PAWN];
			}

		/*********"doubled pawn" is considered here*******/
			if( (i>15))
			{
				if (WhichPiece(i-8) == 13)
					Black -= Chromosome[DOUBLED_PAWNS];
				else
					if( (i>23))
					{
						if (WhichPiece(i-16) == 13)
							Black -= Chromosome[DOUBLED_PAWNS];
						else
							if((i>31))
							{
								if(WhichPiece(i-24) == 13)
									Black -= Chromosome[DOUBLED_PAWNS];
								else
									if((i>39))
									{
										if(WhichPiece(i-32) == 13)
											Black -= Chromosome[DOUBLED_PAWNS];
										else
											if((i>47))
											{
												if (WhichPiece(i-40) == 13)
													Black -= Chromosome[DOUBLED_PAWNS];
											}
									}
							}
					}
			}
		
		/*********"passed pawn" is considered here*******/
			int flag=0;

			if((i==16) || (i==24) || (i==32) || (i==40) || (i==48))
			{
				for(int k=9;k<(i+1);k=k+8)
					if((WhichPiece(k) == 6) || (WhichPiece(k-1) == 6))
					{
						flag=1;
						break;
					}
			}
			else
				if((i==23) || (i==31) || (i==39) || (i==47) || (i==55))
				{
					for(int k=14;k<(i-1);k=k+8)
						if((WhichPiece(k) == 6) || (WhichPiece(k-1) == 6))
						{
							flag=1;
							break;
						}
				}
				else
					if ((i>16) && (i<55))
					{
						for(int k=i-7;k>9;k=k-8)
							if((WhichPiece(k) == 6) || (WhichPiece(k-1) == 6) || (WhichPiece(k-2) == 6))
							{
								flag=1;
								break;
							}
					}

			if (flag == 0)
			{
				Black += Chromosome[PASSED_PAWN];
			
			/*********"rook-supported passed pawn" bonus is given here*******/
				int k=i;
				while (k<56)
				{
					k += 8;
					if (WhichPiece(k) != -1)
						if (WhichPiece(k) == 10)
							Black += Chromosome[ROOK_SUPP_PASSED_PAWN];
						else 
							break;
				}
			}

		/*********"isolated pawn" is considered here*******/
			flag=0;
			if((i==8) || (i==16) || (i==24) || (i==32) || (i==40) || (i==48))
			{
				for(int k=49;k>1;k=k-8)
					if(WhichPiece(k) == 13)
					{
						flag=1;
						break;
					}
			}
			else
				if((i==15) || (i==23) || (i==31) || (i==39) || (i==47) || (i==55))
				{
					for(int k=54;k>6;k=k-8)
						if(WhichPiece(k) == 13)
						{
							flag=1;
							break;
						}
				}
				else
					if ((i>8) && (i<55))
					{
						int tmp=i;
						while (tmp>15)
							tmp-=8;
						
						for(int k=(tmp-1);k<=(tmp+40);k=k+8)
							if((WhichPiece(k) == 13) || (WhichPiece(k+2) == 13))
							{
								flag=1;
								break;
							}
					}

			if (flag == 0)
			{
				isolated = true;
				Black -= Chromosome[ISOLATED_PAWN];
			}

		/*********"backward pawn" and "adjacent pawn" are considered here*******/
			
			flag = 1;
			if(isolated == true)
			{
				flag=0;
				adjacent = 0;
			}
			else
				if (i<55)
				{
					if((i==8) || (i==16) || (i==24) || (i==32) || (i==40) || (i==48))
					{
						for(int k=i+9;k<57;k=k+8)
							if(WhichPiece(k) == 13)
							{
								if (k == i+9)
									adjacent++;

								flag=0;
								break;
							}
					}
					else
						if((i==15) || (i==23) || (i==31) || (i==39) || (i==47) || (i==55))
						{
							for(int k=i+7;k<62;k=k+8)
								if(WhichPiece(k) == 13)
								{
									if (k == i+7)
										adjacent++;

									flag=0;
									break;
								}
						}
						else
							if (i>7)
							{
								for(int k=i+9;k<56;k=k+8)
								{
									if(WhichPiece(k) == 13)
									{
										if (k == i+9)
											adjacent++;
										
										flag=0;
									}

									if(WhichPiece(k-2) == 13)
									{
										if (k == i+9)
											adjacent++;
									
										flag=0;
									}

									if (flag == 0)
										break;
								}
							}
				}

			if (flag == 1)
				Black -= Chromosome[BACKWARD_PAWN];
			
			while(adjacent>0)
			{
				Black += Chromosome[ADJACENT_PAWN];
				adjacent--;
			}
		}//end of pawn if

	}//end of main loop

	return Black;
}