//Substitution for array indices.
//For better understandability
#define QUEEN					0
#define ROOK					1
#define BISHOP					2
#define KNIGHT					3
#define PAWN					4

#define BISHOP_PAIR				5
#define CASTLING_DONE			6
#define CASTLING_MISSED			7
#define ROOK_OPEN_FILE			8
#define ROOK_SOPEN_FILE			9
#define CONNECTED_ROOKS			10
#define LINE7_ROOK				11
#define KNIGHT_OUTPOST			12
#define BISHOP_OUTPOST			13
#define KNIGHT_MOBILITY			14

#define ADJACENT_PAWN			15
#define PASSED_PAWN				16
#define ROOK_SUPP_PASSED_PAWN	17
#define CENTRE_PAWN				18
#define DOUBLED_PAWNS			19
#define BACKWARD_PAWN			20
#define BLOCKED_PAWN			21
#define ISOLATED_PAWN			22

#define LINE1_BISHOP			23
#define LINE1_KNIGHT			24
#define FAR_PAWN				25

///////////////////////////////////////////
//this function returns the evaluation.
///////////////////////////////////////////
int Evaluate (int W, int B);


///////////////////////////////////////////
//this function calculates white's score
///////////////////////////////////////////
int EvaluateWhite(void);


///////////////////////////////////////////
//this function calculates black's score
//in exactly the same manner as it is for white
///////////////////////////////////////////
int EvaluateBlack(void);