#include "stdafx.h"

int BestFromSquare,
	BestToSquare;
//two variables for storing current best move



///////////////////////////////////////////
//This function takes one move back.
//It must be given an array of positional statements,
//which the chessboard had a move ago
///////////////////////////////////////////
void MoveBack(Params Curr)
{
	
	
//the next block just takes the move back,
//according to its type below
/*
REMINDER
Ordinary		   Move = 0
Capture			   Move = 1
Castling		   Move = 2
En Passant Capture Move = 3

Promotion Move:
Ordianry    toQueen  = 401
			toRook   = 402
			toBishop = 403
			toKnight = 404
WithCapture toQueen  = 411
			toRook   = 412
			toBishop = 413
			toKnight = 414
*/

	if (Curr.MoveType == 0)
	{
		RemovePiece(Curr.toSquare,Curr.dep);
		AddPiece(Curr.fromSquare,Curr.dep);
	}
	else
		if (Curr.MoveType == 1)
		{
			RemovePiece(Curr.toSquare,Curr.dep);
			AddPiece(Curr.fromSquare,Curr.dep);
			AddPiece(Curr.toSquare,Curr.dest);
		}
		else
			if (Curr.MoveType == 2)
			{
				//short castling
				if (Curr.toSquare > Curr.fromSquare)
				{
					//moving King
					RemovePiece(Curr.toSquare,Curr.dep);
					AddPiece(Curr.fromSquare,Curr.dep);
					//moving Rook
					AddPiece(Curr.toSquare+1,WhichPiece(Curr.toSquare-1));
					RemovePiece(Curr.toSquare-1,WhichPiece(Curr.toSquare-1));
					
				}
				//long castling
				else
				{
					//moving King
					RemovePiece(Curr.toSquare,Curr.dep);
					AddPiece(Curr.fromSquare,Curr.dep);
					//moving Rook
					AddPiece(Curr.toSquare-2,WhichPiece(Curr.toSquare+1));
					RemovePiece(Curr.toSquare+1,WhichPiece(Curr.toSquare+1));
					
				}

			}
			else
				if (Curr.MoveType == 3)
				{
					//white EnPassant
					if (Curr.toSquare > Curr.fromSquare)
					{
						RemovePiece(Curr.toSquare,Curr.dep);
						AddPiece(Curr.fromSquare,Curr.dep);
						AddPiece(Curr.toSquare-8,13);
					}
					//black EnPassant
					else
					{
						RemovePiece(Curr.toSquare,Curr.dep);
						AddPiece(Curr.fromSquare,Curr.dep);
						AddPiece(Curr.toSquare+8,6);
					}
				}
				else
					//The similar procedures should be performed 
					//for each pormotion type, if implemented
					if (Curr.MoveType == 401)
					{
						RemovePiece(Curr.toSquare,WhichPiece(Curr.toSquare));
						AddPiece(Curr.fromSquare,Curr.dep);
					}
					else
						if (Curr.MoveType = 411)
						{
							RemovePiece(Curr.toSquare,WhichPiece(Curr.toSquare));
							AddPiece(Curr.toSquare,Curr.dest);
							AddPiece(Curr.fromSquare,Curr.dep);
						}
			
	//assigning back all previous position's statements					
	EnPassant = Curr.EnPassant;
	MovingSide = Curr.MovingSide;
	WhiteLongCastling=Curr.WhiteLongCastling;
	WhiteShortCastling=Curr.WhiteShortCastling;
	BlackLongCastling=Curr.BlackLongCastling;
	BlackShortCastling=Curr.BlackShortCastling,
	WhiteCastlingDone=Curr.WhiteCastlingDone;
	BlackCastlingDone=Curr.BlackCastlingDone;
}


///////////////////////////////////////////
//This function performs the full search, without cutting any branch
///////////////////////////////////////////
int FullSearch(int Depth)
{
	int fromSquare = 0,
	    toSquare = 0,
		Score = 0,
		CurrMax = -50000,
		MoveLegalFlag = 0,
		
		PliesToSearch = Depth;

	//this variable stores required position parameters
	//for taking move back
	Params CurrParams;


/****************PRE-SEARCH BLOCK********************/
/****************************************************/

	//if the side is in check after the LAST opponent's move,
	//it must not be mate at least,
	//so that we have to look for a possible reply
	if ((IsAttacked(WhereKing(MovingSide),abs(MovingSide-7)) > 0) && (PliesToSearch == 0))
		PliesToSearch++;

	//If the search limit is achieved,
	if (PliesToSearch == 0)
	{
		//Evaluate the current position
		//from different perspective (for white and for black)
		if (MovingSide == 0)
			Score = Evaluate(EvaluateWhite(),EvaluateBlack());
		else 
			Score = - Evaluate(EvaluateWhite(),EvaluateBlack());
		
		return Score;
	}
/****************************************************/
/************END OF PRE-SEARCH BLOCK*****************/


	//there is still a possibility to go deeper into the search tree
	
	//this is an array of legal moves in the current position
	aMove CurrentMoveList[MoveHistorySize];
	
	int index = 0,
		flag = 0;

	//Move generator.
	//Available moves are now stored in CurrentMoveList
	GenerateMoves(CurrentMoveList,1);

	//while there are moves
	while(flag == 0)
	{
		if (CurrentMoveList[index].fromSquare != -1)
		{
			//take one move
			fromSquare = CurrentMoveList[index].fromSquare;
			toSquare = CurrentMoveList[index].toSquare;

			//store all current position's parameters
			CurrParams.fromSquare = fromSquare;
			CurrParams.dep = WhichPiece(fromSquare);
			CurrParams.toSquare = toSquare;
			CurrParams.dest = WhichPiece(toSquare);
			CurrParams.MoveType = CurrentMoveList[index].Type;
			CurrParams.EnPassant = EnPassant;
			CurrParams.MovingSide = MovingSide;
			CurrParams.WhiteLongCastling=WhiteLongCastling;
			CurrParams.WhiteShortCastling=WhiteShortCastling;
			CurrParams.BlackLongCastling=BlackLongCastling;
			CurrParams.BlackShortCastling=BlackShortCastling,
			CurrParams.WhiteCastlingDone=WhiteCastlingDone;
			CurrParams.BlackCastlingDone=BlackCastlingDone;

			//make this move
			if(Move(fromSquare,toSquare,SetMoveType(fromSquare,toSquare)) == true)
			{
				//if we are here, there is at least one move.
				//Hence, it is neither mate nor stalemate.
				//So let's infrom the program about it
				MoveLegalFlag = 1;
			
				//recursive search for the current child position
				Score = -FullSearch(PliesToSearch-1);
					
				//if better move found, assume its score
				if (Score > CurrMax)
					CurrMax = Score;
					
				//the search is done for this move,
				//take it back
				MoveBack(CurrParams);
			}
			//switch to the next move in CurrentMoveList
			index++;
		}
		//no more moves available,
		//break the search loop
		else
			flag = 1;
	}//end of "while there are moves" while-statement

	//if there were no truly legal moves found
	if (MoveLegalFlag == 0)
	{
		//if our king is under attack,
		//it is a mate
		if(IsAttacked(WhereKing(MovingSide),abs(MovingSide-7)) > 0)
			CurrMax = -20000;
		//and a stalemate otherwise
		else
			CurrMax = 0;
	}

	return CurrMax;
}

///////////////////////////////////////////
//this function checks, 
//if a position in question is in the transposition table
///////////////////////////////////////////
bool isInTransTable(int PrHashKey, int SecHashKey, int PliesToSearch)
{
	//get the index of a transposition table entry
	int key = abs(PrHashKey % TT_Size);

	//the second hash key differs
	if (TransTable[key].SHK != SecHashKey)
		return false;

	//the depth of the previous search is worse
	//than the expected one
	if (TransTable[key].Depth < PliesToSearch)
			return false;

return true;
}

///////////////////////////////////////////
//this function adds a position in question to the transposition table
///////////////////////////////////////////
void AddToTransTable(int PrimaryHashKey, int SecondaryHashKey, int Score, int Depth)
{
	//get the index of a transposition table entry
	int key = abs(PrimaryHashKey % TT_Size);

	TransTable[key].PHK = PrimaryHashKey;
	TransTable[key].SHK = SecondaryHashKey;
	TransTable[key].Depth = Depth;
	TransTable[key].Value = Score;
}


///////////////////////////////////////////
//This function performs the alpha(a)-beta(b) search to a fixed depth.
//No Iterative Deepening!
///////////////////////////////////////////
int AB_Search(int Depth, int a, int b)
{
	int fromSquare = 0,
	    toSquare = 0,
		Score = 0,
		CurrMax = 0,

		//flags for checking different conditions
		MoveLegalFlag = 0,
		inCheckFlag = 0,

		PliesToSearch = Depth;

	//this variable stores required position parameters
	//for taking move back
	Params CurrParams;

	//thiese variables store Zobrist's hash keys for the position,
	//from which this function is called
	int CurrentPrimaryHashKey = 0,
		CurrentSecondaryHashKey = 0;


/****************PRE-SEARCH BLOCK********************/
/****************************************************/
	
	//Compute hash keys for the current position
	CurrentPrimaryHashKey = ComputePrimaryHashKey();
	CurrentSecondaryHashKey = ComputeSecondaryHashKey();

	//if the side is in check after the LAST opponent's move,
	//it must not be mate at least,
	//so that we have to look for a possible reply
	if ((IsAttacked(WhereKing(MovingSide),abs(MovingSide-7)) > 0) && (PliesToSearch == 0))
		PliesToSearch++;

	//if the position is in transposition table already,
	//simply return its value
	if ((isInTransTable(CurrentPrimaryHashKey,CurrentSecondaryHashKey,PliesToSearch)) == true)
	{
		int key = abs(CurrentPrimaryHashKey % TT_Size);

		return TransTable[key].Value;
	}

	//if the search limit is achieved,
	if (PliesToSearch == 0)
	{
		//Evaluate the current position
		//from different perspective (for white and for black)
		if (MovingSide == 0)
			Score = Evaluate(EvaluateWhite(),EvaluateBlack());
		else 
			Score = -Evaluate(EvaluateWhite(),EvaluateBlack());
		
		//store the result in the transposition table
		AddToTransTable(CurrentPrimaryHashKey,CurrentSecondaryHashKey,Score,PliesToSearch);
		
		return Score;
	}
/****************************************************/
/************END OF PRE-SEARCH BLOCK*****************/


//there is still a possibility to go deeper into the search tree
	
	//according to a-b algorithm
	CurrMax = a;

	//stores available moves
	aMove CurrentMoveList[MoveHistorySize];
	
	//some indices
	int index = 0,
		flag = 0;

	//Move generator.
	//Available moves are now stored in CurrentMoveList
	GenerateMoves(CurrentMoveList,1);

	//while there are moves and
	//while there is not a cutoff
	while(flag == 0)
	{
		if (CurrentMoveList[index].fromSquare != -1)
		{
			//take one move
			fromSquare = CurrentMoveList[index].fromSquare;
			toSquare = CurrentMoveList[index].toSquare;

			//store all current position's parameters
			CurrParams.fromSquare = fromSquare;
			CurrParams.dep = WhichPiece(fromSquare);
			CurrParams.toSquare = toSquare;
			CurrParams.dest = WhichPiece(toSquare);
			CurrParams.MoveType = CurrentMoveList[index].Type;
			CurrParams.EnPassant = EnPassant;
			CurrParams.MovingSide = MovingSide;
			CurrParams.WhiteLongCastling=WhiteLongCastling;
			CurrParams.WhiteShortCastling=WhiteShortCastling;
			CurrParams.BlackLongCastling=BlackLongCastling;
			CurrParams.BlackShortCastling=BlackShortCastling,
			CurrParams.WhiteCastlingDone=WhiteCastlingDone;
			CurrParams.BlackCastlingDone=BlackCastlingDone;

			//make this move
			if(Move(fromSquare,toSquare,SetMoveType(fromSquare,toSquare)) == true)
			{
				//if we are here, there is at least one move.
				//Hence, it is neither mate nor stalemate.
				//So let's infrom the program about it
				MoveLegalFlag = 1;
				
				//recursive a-b search from the current position
				Score = -AB_Search(PliesToSearch-1, -b, -CurrMax);
					
				//if better move is found, assume its score
				if (Score > CurrMax)
					CurrMax = Score;

				//cut-off happened
				if (CurrMax >= b ) 
				{
					//take back the move made
					MoveBack(CurrParams);

					//and break the current search
					break;
				}

				//not a cut-off,
				//take the move back
				MoveBack(CurrParams);
			}
			//and proceed to the next move
			index++;
		}
		//no more moves available,
		//break the search loop
		else
			flag = 1;
	}//end of "while there are moves" while-statement

	//if there were no truly legal moves found
	if (MoveLegalFlag == 0)
	{
		//if our king is under attack,
		//it is a mate
		if(IsAttacked(WhereKing(MovingSide),abs(MovingSide-7)) > 0)
			CurrMax = -20000;
		//and a stalemate otherwise
		else
			CurrMax = 0;
	}

/***********************POST_SEARCH BLOCK***********************/
//The program shows obviously faster performance without this
//storing of non-leaf positions.
//I think, it might be due to the peculiarity of the present TT renewal.
/***************************************************************/
//so, this block is not used by the search
	
//	if (isInTransTable(CurrentPrimaryHashKey,CurrentSecondaryHashKey,PliesToSearch) == false)
//		AddToTransTable(CurrentPrimaryHashKey,CurrentSecondaryHashKey,CurrMax,PliesToSearch);

/***************************************************************/
/************END OF POST_SEARCH BLOCK***************************/
						
	return CurrMax;
}


///////////////////////////////////////////
//this function uses Shannon's type-A strategy, 
//i.e. all top level moves are considered
///////////////////////////////////////////
int FindMove(int PliesToSearch)
{
	int fromSquare = 0,
	    toSquare = 0,
		Score = 0,
		CurrMax =-50000,
		
		rnd=0,
	
		//alpha-beta bounds
		a = -AB_Bound,
		b =  AB_Bound;

	//stores current position parameters
	Params CurrParams;

	//set random number generator
	srand( (unsigned)time( NULL ) );

	//according to the algorithm
	CurrMax = a;

	//stores available moves
	aMove CurrentMoveList[MoveHistorySize],
		  
		  //used for temporary storage of a move
		  Temp;
	
	int index = 0,
		flag = 0,
		ValidMoveFlag = 0;

	//Move generator,
	//the moves are now in CurrentMoveList
	GenerateMoves(CurrentMoveList,0);
			
	//some visualisation
	//printf("%d are moving\n",MovingSide);

	//while there are moves
	while(flag == 0)
	{
		if (CurrentMoveList[index].fromSquare != -1)
		{
			//take one move
			fromSquare = CurrentMoveList[index].fromSquare;
			toSquare = CurrentMoveList[index].toSquare;
				
			//store all position's parameters
			CurrParams.fromSquare = fromSquare;
			CurrParams.dep = WhichPiece(fromSquare);
			CurrParams.toSquare = toSquare;
			CurrParams.dest = WhichPiece(toSquare);
			CurrParams.MoveType = CurrentMoveList[index].Type;
			CurrParams.EnPassant = EnPassant;
			CurrParams.MovingSide = MovingSide;

			CurrParams.WhiteLongCastling=WhiteLongCastling;
			CurrParams.WhiteShortCastling=WhiteShortCastling;
			CurrParams.BlackLongCastling=BlackLongCastling;
			CurrParams.BlackShortCastling=BlackShortCastling,
			CurrParams.WhiteCastlingDone=WhiteCastlingDone;
			CurrParams.BlackCastlingDone=BlackCastlingDone;

			//make the move
			if(Move(fromSquare,toSquare,SetMoveType(fromSquare,toSquare)) == true)
			{
				ValidMoveFlag = 1;
				
				//some visualisation
				//printf("the variants after %d moves as %d - %d are\n",abs(MovingSide-7),fromSquare,toSquare);
				//printf("---------------\n");
					
				//with these two you choose the method of move finding
				Score = -AB_Search(PliesToSearch-1,a,b);
				//Score = -FullSearch(PliesToSearch-1);

				//some visualisation
				//printf("Score=%d, CurrMax=%d\n",Score,CurrMax);
					
				//if the move achieves equal score to the current best one,
				//a random number decides if it is now considered to be the best, or not
				if (Score == CurrMax)
				{
					rnd=rand();
					rnd=rnd%2;
					if (rnd == 0)
					{
						BestFromSquare = fromSquare;
						BestToSquare = toSquare;
					}
				}
					
				//if better move found, assume its score
				if (Score > CurrMax)
				{
					CurrMax = Score;
					BestFromSquare = fromSquare;
					BestToSquare = toSquare;
					
					//some visualisation
					//printf("new best for %d with the score %d is %d - %d\n",abs(MovingSide-7),CurrMax,fromSquare,toSquare);
				}

				//the move is searched, take it back
				MoveBack(CurrParams);
			}//end of MakeMove if statement

			/****************************************/
			//the next block stores the observed move in Good or Bad moves, if necessary
			Temp.fromSquare = CurrentMoveList[index].fromSquare;
			Temp.toSquare = CurrentMoveList[index].toSquare;
			Temp.Type = CurrentMoveList[index].Type;
			Temp.AttackStatus = CurrentMoveList[index].AttackStatus;
			Temp.Score = Score;

			int i = 0;

			aMove SubTemp;

			while (i < 5)
			{
				if (Temp.Score > GoodMoves[i].Score )
				{
					SubTemp.fromSquare = GoodMoves[i].fromSquare;
					SubTemp.toSquare = GoodMoves[i].toSquare;
					SubTemp.Type = GoodMoves[i].Type;
					SubTemp.AttackStatus = GoodMoves[i].AttackStatus;
					SubTemp.Score = GoodMoves[i].Score;

					GoodMoves[i].fromSquare = Temp.fromSquare;
					GoodMoves[i].toSquare = Temp.toSquare;
					GoodMoves[i].Type = Temp.Type;
					GoodMoves[i].AttackStatus = Temp.AttackStatus;
					GoodMoves[i].Score = Temp.Score;

					Temp.fromSquare = SubTemp.fromSquare;
					Temp.toSquare = SubTemp.toSquare;
					Temp.Type = SubTemp.Type;
					Temp.AttackStatus = SubTemp.AttackStatus;
					Temp.Score = SubTemp.Score;
				}
				i++;
			}
				
			i = 0;
			Temp.fromSquare = CurrentMoveList[index].fromSquare;
			Temp.toSquare = CurrentMoveList[index].toSquare;
			Temp.Type = CurrentMoveList[index].Type;
			Temp.AttackStatus = CurrentMoveList[index].AttackStatus;
			Temp.Score = Score;

			while (i < 5)
			{
				if (Temp.Score < BadMoves[i].Score )
				{
					SubTemp.fromSquare = BadMoves[i].fromSquare;
					SubTemp.toSquare = BadMoves[i].toSquare;
					SubTemp.Type = BadMoves[i].Type;
					SubTemp.AttackStatus = BadMoves[i].AttackStatus;
					SubTemp.Score = BadMoves[i].Score;

					BadMoves[i].fromSquare = Temp.fromSquare;
					BadMoves[i].toSquare = Temp.toSquare;
					BadMoves[i].Type = Temp.Type;
					BadMoves[i].AttackStatus = Temp.AttackStatus;
					BadMoves[i].Score = Temp.Score;

					Temp.fromSquare = SubTemp.fromSquare;
					Temp.toSquare = SubTemp.toSquare;
					Temp.Type = SubTemp.Type;
					Temp.AttackStatus = SubTemp.AttackStatus;
					Temp.Score = SubTemp.Score;
				}
				i++;
			}
			/****************************************/

			//go to the next move
			index++;
		}
		//no more moves
		else
		{
			flag = 1;
			//there was no valid move
			if (ValidMoveFlag == 0)
			{
				//stalemate
				if (IsAttacked(WhereKing(MovingSide),abs(MovingSide-7)) == 0)
					CurrMax = 0;
				//checkmate
				else
					CurrMax = -20000;
			}
		}
	}//end of "while there are moves"
	
	return CurrMax;
}

///////////////////////////////////////////
//this function generates the moves for the current position
///////////////////////////////////////////
void GenerateMoves(aMove *CurrentMoveList, int flag)
{
	int fromSquare = 0,
		toSquare = 0,
			
		//white was decided to start looking for moves from h8, black from a1
		//increment provides this
		increment = 1,

		index = 0;
		
	__int64 tmp=0,
			tmpBB=0;

	//stores current position parameters
	Params CurrParams;

	//stores moves
	aMove TempMoveList[MoveHistorySize];

	
	//clean both temporary and final move repositories
	for (int i=0;i<MoveHistorySize;i++)
	{
		TempMoveList[i].fromSquare = -1;
		TempMoveList[i].toSquare = -1;
		TempMoveList[i].Type = -1;
		TempMoveList[i].AttackStatus = -100;

		CurrentMoveList[i].fromSquare = -1;
		CurrentMoveList[i].toSquare = -1;
		CurrentMoveList[i].Type = -1;
		CurrentMoveList[i].AttackStatus = -100;
	}

	
	//all 'side-on-move' pieces bitboard
	tmpBB=BitBoards[MovingSide];

	//sets the direction of observing the chessboard
	if (MovingSide == 0)
	{
		fromSquare = 63;
		toSquare = 63;
		increment = -1;
	}
	else 
	{
		fromSquare = 0;
		toSquare = 0;
		increment = 1;
	}
	
	//while there are pieces
	while (tmpBB != 0)
	{

		//take one piece 
		while((Squares[fromSquare] & tmpBB) == 0)
			fromSquare = fromSquare + increment;
		
		//and remove it from the consideration
		tmpBB ^= Squares[fromSquare];
		
		//for the piece selected
		
		//generate all its moves
		tmp=ComputeMoves(WhichPiece(fromSquare),fromSquare);
		
		
		//set the fields for every new search
		if (MovingSide == 0)
			toSquare = 63;
		else 
			toSquare = 0;

		//while there are moves of that piece
		while(tmp != 0)
		{
			
			//take one
			while((Squares[toSquare] & tmp) == 0)
				toSquare = toSquare + increment;

			//delete it from consideration
			tmp ^= Squares[toSquare];

			//store all position's parameters
			CurrParams.fromSquare = fromSquare;
			CurrParams.dep = WhichPiece(fromSquare);
			CurrParams.toSquare = toSquare;
			CurrParams.dest = WhichPiece(toSquare);
			CurrParams.MoveType = SetMoveType(fromSquare,toSquare);
			CurrParams.EnPassant = EnPassant;
			CurrParams.MovingSide = MovingSide;
			CurrParams.WhiteLongCastling=WhiteLongCastling;
			CurrParams.WhiteShortCastling=WhiteShortCastling;
			CurrParams.BlackLongCastling=BlackLongCastling;
			CurrParams.BlackShortCastling=BlackShortCastling,
			CurrParams.WhiteCastlingDone=WhiteCastlingDone;
			CurrParams.BlackCastlingDone=BlackCastlingDone;

			
			if (Move(fromSquare,toSquare,CurrParams.MoveType) == true)
			{
				//add move to MoveList
				TempMoveList[index].fromSquare = fromSquare;
				TempMoveList[index].toSquare = toSquare;
				TempMoveList[index].Type = CurrParams.MoveType;
				TempMoveList[index].AttackStatus = IsAttacked(toSquare,MovingSide)-IsAttacked(toSquare,abs(MovingSide-7));
				
				//take the move back and go to the next one
				MoveBack(CurrParams);
				index++;
			}
				
		}
	}

/********************************		
//Now the moves must be ordered
*********************************/
		
//First, let's check Moves' history
int j = 0,
	counterGood = 0,
	counterBad = 0;

aMove Temp;


//if the moves are generated on the top level, look for the history
//otherwise, not
if (flag == 0)
{
		//for GoodMoves
		for (j = 0; j < 5; j++)
		{
			for (i = 0; i < index; i++)
			{
				if ((TempMoveList[i].fromSquare == GoodMoves[j].fromSquare) &&
					(TempMoveList[i].toSquare == GoodMoves[j].toSquare) &&
					(TempMoveList[i].Type == GoodMoves[j].Type) )
				{
					Temp.fromSquare = TempMoveList[counterGood].fromSquare;
					Temp.toSquare = TempMoveList[counterGood].toSquare;
					Temp.Type = TempMoveList[counterGood].Type;
					Temp.AttackStatus = TempMoveList[counterGood].AttackStatus;
					Temp.Score = TempMoveList[counterGood].Score;

					TempMoveList[counterGood].fromSquare = TempMoveList[i].fromSquare;
					TempMoveList[counterGood].toSquare = TempMoveList[i].toSquare;
					TempMoveList[counterGood].Type = TempMoveList[i].Type;
					TempMoveList[counterGood].AttackStatus = TempMoveList[i].AttackStatus;
					TempMoveList[counterGood].Score = TempMoveList[i].Score;

					TempMoveList[i].fromSquare = Temp.fromSquare;
					TempMoveList[i].toSquare = Temp.toSquare;
					TempMoveList[i].Type = Temp.Type;
					TempMoveList[i].AttackStatus = Temp.AttackStatus;
					TempMoveList[i].Score = Temp.Score;

					counterGood++;
				}
			}
		}

		//for BadMoves
		counterBad = 0;
		for (j = 0; j < 5; j++)
		{
			for (i = index-1; i >= counterGood; i--)
			{
				if ((TempMoveList[i].fromSquare == BadMoves[j].fromSquare) &&
					(TempMoveList[i].toSquare == BadMoves[j].toSquare) &&
					(TempMoveList[i].Type == BadMoves[j].Type) )
				{
					Temp.fromSquare = TempMoveList[index-1-counterBad].fromSquare;
					Temp.toSquare = TempMoveList[index-1-counterBad].toSquare;
					Temp.Type = TempMoveList[index-1-counterBad].Type;
					Temp.AttackStatus = TempMoveList[index-1-counterBad].AttackStatus;
					Temp.Score = TempMoveList[index-1-counterBad].Score;

					TempMoveList[index-1-counterBad].fromSquare = TempMoveList[i].fromSquare;
					TempMoveList[index-1-counterBad].toSquare = TempMoveList[i].toSquare;
					TempMoveList[index-1-counterBad].Type = TempMoveList[i].Type;
					TempMoveList[index-1-counterBad].AttackStatus = TempMoveList[i].AttackStatus;
					TempMoveList[index-1-counterBad].Score = TempMoveList[i].Score;

					TempMoveList[i].fromSquare = Temp.fromSquare;
					TempMoveList[i].toSquare = Temp.toSquare;
					TempMoveList[i].Type = Temp.Type;
					TempMoveList[i].AttackStatus = Temp.AttackStatus;
					TempMoveList[i].Score = Temp.Score;

					counterBad++;
				}
			}
		}

//with these two, the results obtained so far can be seen
//printf("--------------%d %d\n",counterGood,counterBad);
//ShowMoves(TempMoveList);

}

	//bounds of 'still unsorted' array
	int NewStart = counterGood,
		NewFinish = index - counterBad;

		
		
		
/************REMINDER**************
//some sorting algorithm in Pascal
//copied from somewhere

  procedure SortInsert (var Arr : array of Integer; n : Integer);
var
  i, j, Temp : Integer;
begin
  for i := 1 to n do begin
    Temp := Arr [i];
    j := i - 1;
    while Temp < Arr [j] do begin
      Arr [j + 1] := Arr [j];
      Dec (j);
      if j < 0 then
        Break;
    end;
    Arr [j + 1] := Temp;
  end;
end;
/**********************************/		
	
	for (i = NewStart + 1; i < NewFinish; i++)
	{
		Temp.fromSquare = TempMoveList[i].fromSquare;
		Temp.toSquare = TempMoveList[i].toSquare;
		Temp.Type = TempMoveList[i].Type;
		Temp.AttackStatus = TempMoveList[i].AttackStatus;
			
		j = i-1;

		while (Temp.AttackStatus < TempMoveList[j].AttackStatus)
		{
			TempMoveList[j+1].fromSquare = TempMoveList[j].fromSquare;
			TempMoveList[j+1].toSquare = TempMoveList[j].toSquare;
			TempMoveList[j+1].Type = TempMoveList[j].Type;
			TempMoveList[j+1].AttackStatus = TempMoveList[j].AttackStatus;
			j--;

			if (j<NewStart)
				break;
		}

		TempMoveList[j+1].fromSquare = Temp.fromSquare;
		TempMoveList[j+1].toSquare = Temp.toSquare;
		TempMoveList[j+1].Type = Temp.Type;
		TempMoveList[j+1].AttackStatus = Temp.AttackStatus;
	}

		/*********REMINDER*************
		The type of the move to be made

		Ordinary		   Move = 0
		Capture			   Move = 1
		Castling		   Move = 2
		En Passant Capture Move = 3
		Promotion Move:
		Ordianry    toQueen  = 401
					toRook   = 402
					toBishop = 403
					toKnight = 404
		WithCapture toQueen  = 411
					toRook   = 412
					toBishop = 413
					toKnight = 414
		********************************/

	/***************************************/
	//second step of move ordering
	int counter1 = NewStart;
	int counter2 = 0;


	for (i = 0; i<NewStart;i++)
	{
			CurrentMoveList[i].fromSquare = TempMoveList[i].fromSquare;
			CurrentMoveList[i].toSquare = TempMoveList[i].toSquare;
			CurrentMoveList[i].Type = TempMoveList[i].Type;
			CurrentMoveList[i].AttackStatus = TempMoveList[i].AttackStatus;
	}

	for (i = NewStart; i < NewFinish; i++)
	{
		if ((TempMoveList[i].Type == 1) || (TempMoveList[i].Type == 3) || (TempMoveList[i].Type == 411))
		{
			CurrentMoveList[counter1].fromSquare = TempMoveList[i].fromSquare;
			CurrentMoveList[counter1].toSquare = TempMoveList[i].toSquare;
			CurrentMoveList[counter1].Type = TempMoveList[i].Type;
			CurrentMoveList[counter1].AttackStatus = TempMoveList[i].AttackStatus;
			counter1++;

			TempMoveList[i].fromSquare = -1;
			TempMoveList[i].toSquare = -1;
			TempMoveList[i].Type = -1;
			TempMoveList[i].AttackStatus = -1;

		}
	}

	for (i = NewStart; i < NewFinish; i++)
	{
		if ((TempMoveList[i].Type == 0) || (TempMoveList[i].Type == 2) || (TempMoveList[i].Type == 401))
		{
			CurrentMoveList[counter1+counter2].fromSquare = TempMoveList[i].fromSquare;
			CurrentMoveList[counter1+counter2].toSquare = TempMoveList[i].toSquare;
			CurrentMoveList[counter1+counter2].Type = TempMoveList[i].Type;
			CurrentMoveList[counter1+counter2].AttackStatus = TempMoveList[i].AttackStatus;
			counter2++;

			TempMoveList[i].fromSquare = -1;
			TempMoveList[i].toSquare = -1;
			TempMoveList[i].Type = -1;
			TempMoveList[i].AttackStatus = -1;
		}
	}
		
	for (i = NewFinish; i < index; i++)
	{
			CurrentMoveList[i].fromSquare = TempMoveList[i].fromSquare;
			CurrentMoveList[i].toSquare = TempMoveList[i].toSquare;
			CurrentMoveList[i].Type = TempMoveList[i].Type;
			CurrentMoveList[i].AttackStatus = TempMoveList[i].AttackStatus;
	}
	/***************************************/
	
	//Moves are generated, 
	//so History moves can be 'emptied' on the top level
	if (flag == 0)
	{
		for (i = 0; i < 5; i++)
		{
			GoodMoves[i].fromSquare = -1;
			GoodMoves[i].toSquare = -1;
			GoodMoves[i].Type = -1;
			GoodMoves[i].AttackStatus = -100;
			GoodMoves[i].Score = -1000;

			BadMoves[i].fromSquare = -1;
			BadMoves[i].toSquare = -1;
			BadMoves[i].Type = -1;
			BadMoves[i].AttackStatus = -100;
			BadMoves[i].Score = 1000;
		}
	}
}


///////////////////////////////////////////
//this function shows moves generated
///////////////////////////////////////////
void ShowMoves(aMove *CurrentMoveList)
{
	int i = 0;

	printf("Generated moves are\n");
	while(CurrentMoveList[i].Type != -1)
	{
			printf("%d - %d ",CurrentMoveList[i].fromSquare,CurrentMoveList[i].toSquare);
			printf("of type %d and %d attacks\n",CurrentMoveList[i].Type, CurrentMoveList[i].AttackStatus);
			i++;
	}
}


///////////////////////////////////////////
//this function shows outstanding moves of the previous search
///////////////////////////////////////////
void ShowHistory(void)
{
	int i = 0;

	printf("GoodMoves are\n");
	for (i = 0; i < 5; i++)
	{
		printf("move %d-%d with type %d",GoodMoves[i].fromSquare,GoodMoves[i].toSquare,GoodMoves[i].Type);
		printf(" and %d attacks of score %d\n",GoodMoves[i].AttackStatus,GoodMoves[i].Score);
	}

	printf("BadMoves are\n");
	for (i = 0; i < 5; i++)
	{
		printf("move %d-%d with type %d",BadMoves[i].fromSquare,BadMoves[i].toSquare,BadMoves[i].Type);
		printf(" and %d attacks of score %d\n",BadMoves[i].AttackStatus,BadMoves[i].Score);
	}
}